Перем КодВыполнения;
Перем ЧастиШаблона;
Перем РегулярноеВыражение;

Перем ТекстШаблона;

Процедура ПриСозданииОбъекта(Текст)

	ТекстШаблона = Текст;

	РегулярноеВыражение = Новый РегулярноеВыражение("(\{\{[^}]+\}\})|(\{%[^%]+%\})");

	ПодготовитьКодШаблона();
	
КонецПроцедуры

Процедура ПодготовитьКодШаблона()

	ИнициализацияПеременных();

	Совпадения = РегулярноеВыражение.НайтиСовпадения(ТекстШаблона);

	Позиция = 1;

	Для Каждого Совпадение из Совпадения Цикл
		ТекущаяПозиция = Совпадение.Индекс + 1;
		Если ТекущаяПозиция > Позиция Тогда
			Ид = ДобавитьЧастьШаблона(Сред(ТекстШаблона, Позиция, ТекущаяПозиция - Позиция));
			ЧастьКодаВставкаЧастиШаблона(Ид);
		КонецЕсли;

		ДобавитьЧастьКода(Сред(Совпадение.Значение, 3, Совпадение.Длина - 4), 
								ЭтоВыражение(Совпадение.Значение));

		Позиция = ТекущаяПозиция + Совпадение.Длина;

	КонецЦикла;

	ДлинаТекста = СтрДлина(ТекстШаблона) + 1;

	Если Позиция < ДлинаТекста Тогда
		Ид = ДобавитьЧастьШаблона(Прав(ТекстШаблона, ДлинаТекста - Позиция));
		ЧастьКодаВставкаЧастиШаблона(Ид);
	КонецЕсли;

КонецПроцедуры

Функция ЭтоВыражение(Текст)
	Возврат СтрНачинаетсяС(Текст, "{{");
КонецФункции

Процедура ИнициализацияПеременных()

	КодВыполнения = Новый Массив();
	ЧастиШаблона = Новый Соответствие();
	
КонецПроцедуры


Функция СформироватьТекст(Контекст = Неопределено) Экспорт


	Результат = Новый Массив;

	ЗаполнитьМассивКодом(Результат, Контекст);

	ТекстОтображения = СтрСоединить(Результат, "");

	Возврат ТекстОтображения;

КонецФункции

Процедура ЗаполнитьМассивКодом(Результат, Контекст)

	// Для обратной совместимости в winow
	Модель = Контекст;

	ВесьКод = СтрСоединить(КодВыполнения);
	Выполнить(ВесьКод);
	
КонецПроцедуры

Процедура ДобавитьЧастьКода(ЧастьКода, ЭтоВыражение)

	Если ЭтоВыражение Тогда
		КодКДобавлению = СтрШаблон("_Значение = Строка(%1);
									|Результат.Добавить(_Значение);", ЧастьКода);
		КодВыполнения.Добавить(КодКДобавлению + Символы.ПС);
	Иначе
		КодВыполнения.Добавить(ЧастьКода + Символы.ПС);
	КонецЕсли;

КонецПроцедуры

Процедура ЧастьКодаВставкаЧастиШаблона(Ид)

	Код = СтрШаблон("Результат.Добавить(ЧастиШаблона[""%1""]);", Ид);
	КодВыполнения.Добавить(Код + Символы.ПС);
	
КонецПроцедуры

Функция ДобавитьЧастьШаблона(Строка)

	Ид = ХешироватьСтроку(Строка);
	
	ЧастиШаблона.Вставить(Ид, Строка);

	Возврат Ид;
	
КонецФункции

Функция ХешироватьСтроку(Строка)  
	
	Хеширование = Новый ХешированиеДанных(ХешФункция.MD5);
	
	Хеширование.Добавить(Строка);
	
	Возврат Base64Строка(Хеширование.ХешСумма);
	
КонецФункции

Функция ВывестиПоШаблону(ТекстШаблона, Контекст)

	ВложенныйШаблон = НовыйЭкземплярШаблона(ТекстШаблона); 
	
	Возврат ВложенныйШаблон.СформироватьТекст(Контекст);

КонецФункции

Функция НовыйЭкземплярШаблона(ТекстШаблона)

	Возврат Новый Шаблон(ТекстШаблона);

КонецФункции 